Display a layer from a WFS service, requesting only features for the current extent.

Use case
WFS is an open standard with functionality similar to ArcGIS feature services. The ArcGIS Maps SDK for Qt support for WFS allows you to interoperate with open systems, which are often used in inter-agency efforts, like those for disaster relief.
How to use the sample
Pan and zoom to see features within the current map extent.
How it works
- Create a
WfsFeatureTablewith a URL and table name. - Create a
FeatureLayerfrom the feature table and add it to the map. - Listen for the
MapView::navigatingChangedsignal to detect when the user has stopped navigating the map. - When the user is finished navigating, use
populateFromServiceAsyncto load the table with data for the current visible extent.
Relevant API
- FeatureLayer
- MapView::navigatingChanged
- WfsFeatureTable
- WfsFeatureTable::populateFromServiceAsync
About the data
This service shows building footprints for downtown Seattle. For additional information, see the underlying service on ArcGIS Online.
Tags
browse, catalog, feature, interaction cache, layers, OGC, service, web, WFS
Sample Code
// [WriteFile Name=DisplayWfsLayer, Category=Layers]// [Legal]// Copyright 2019 Esri.//// Licensed under the Apache License, Version 2.0 (the "License");// you may not use this file except in compliance with the License.// You may obtain a copy of the License at// http://www.apache.org/licenses/LICENSE-2.0//// Unless required by applicable law or agreed to in writing, software// distributed under the License is distributed on an "AS IS" BASIS,// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.// See the License for the specific language governing permissions and// limitations under the License.// [Legal]
#ifdef PCH_BUILD#include "pch.hpp"#endif // PCH_BUILD
// sample headers#include "DisplayWfsLayer.h"
// ArcGIS Maps SDK headers#include "CoreTypes.h"#include "Envelope.h"#include "Error.h"#include "FeatureLayer.h"#include "GeodatabaseTypes.h"#include "LayerListModel.h"#include "Map.h"#include "MapQuickView.h"#include "MapTypes.h"#include "Polygon.h"#include "QueryParameters.h"#include "SimpleLineSymbol.h"#include "SimpleRenderer.h"#include "SpatialReference.h"#include "SymbolTypes.h"#include "Viewpoint.h"#include "WfsFeatureTable.h"
// Qt headers#include <QFuture>
using namespace Esri::ArcGISRuntime;
DisplayWfsLayer::DisplayWfsLayer(QObject* parent /* = nullptr */): QObject(parent), m_map(new Map(BasemapStyle::ArcGISTopographic, this)){ // create WFS Feature Table m_wfsFeatureTable = new WfsFeatureTable(QUrl("https://dservices2.arcgis.com/ZQgQTuoyBrtmoGdP/arcgis/services/Seattle_Downtown_Features/WFSServer?service=wfs&request=getcapabilities"), "Seattle_Downtown_Features:Buildings", this);
// Set feature request mode to manual - only manual is supported at v100.5. // In this mode, you must manually populate the table - panning and zooming // won't request features automatically. m_wfsFeatureTable->setFeatureRequestMode(FeatureRequestMode::ManualCache);
// populate the feature table once loaded connect(m_wfsFeatureTable, &WfsFeatureTable::doneLoading, this, [this](const Error& e) { if (e.isEmpty()) populateWfsFeatureTable(); });
// create feature layer from the feature table FeatureLayer* featureLayer = new FeatureLayer(m_wfsFeatureTable, this);
// add a renderer to the layer SimpleLineSymbol* sls = new SimpleLineSymbol(SimpleLineSymbolStyle::Solid, QColor("red"), 3.0f, this); SimpleRenderer* sr = new SimpleRenderer(sls, this); featureLayer->setRenderer(sr);
// add the layer to the map m_map->operationalLayers()->append(featureLayer);
// set initial viewpoint Envelope env(-122.341581, 47.613758, -122.332662, 47.617207, SpatialReference::wgs84()); m_map->setInitialViewpoint(Viewpoint(env));}
DisplayWfsLayer::~DisplayWfsLayer() = default;
void DisplayWfsLayer::init(){ // Register the map view for QML qmlRegisterType<MapQuickView>("Esri.Samples", 1, 0, "MapView"); qmlRegisterType<DisplayWfsLayer>("Esri.Samples", 1, 0, "DisplayWfsLayerSample");}
MapQuickView* DisplayWfsLayer::mapView() const{ return m_mapView;}
// Set the view (created in QML)void DisplayWfsLayer::setMapView(MapQuickView* mapView){ if (!mapView || mapView == m_mapView) { return; }
m_mapView = mapView; m_mapView->setMap(m_map);
connect(m_mapView, &MapQuickView::navigatingChanged, this, [this]() { if (m_mapView->isNavigating()) return;
populateWfsFeatureTable(); });
emit mapViewChanged();}
void DisplayWfsLayer::populateWfsFeatureTable(){ if (!m_mapView || !m_wfsFeatureTable) return;
// create query parameters QueryParameters params; params.setGeometry(m_mapView->visibleArea().extent()); params.setSpatialRelationship(SpatialRelationship::Intersects);
// query the service constexpr bool clearCache = false; const QStringList outFields = {"*"}; auto future = m_wfsFeatureTable->populateFromServiceAsync(params, clearCache, outFields); Q_UNUSED(future)}// [WriteFile Name=DisplayWfsLayer, Category=Layers]// [Legal]// Copyright 2019 Esri.//// Licensed under the Apache License, Version 2.0 (the "License");// you may not use this file except in compliance with the License.// You may obtain a copy of the License at// http://www.apache.org/licenses/LICENSE-2.0//// Unless required by applicable law or agreed to in writing, software// distributed under the License is distributed on an "AS IS" BASIS,// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.// See the License for the specific language governing permissions and// limitations under the License.// [Legal]
#ifndef DISPLAYWFSLAYER_H#define DISPLAYWFSLAYER_H
// Qt headers#include <QObject>
namespace Esri::ArcGISRuntime{class Map;class MapQuickView;class WfsFeatureTable;}
Q_MOC_INCLUDE("MapQuickView.h")
class DisplayWfsLayer : public QObject{ Q_OBJECT
Q_PROPERTY(Esri::ArcGISRuntime::MapQuickView* mapView READ mapView WRITE setMapView NOTIFY mapViewChanged)
public: explicit DisplayWfsLayer(QObject* parent = nullptr); ~DisplayWfsLayer();
static void init();
signals: void mapViewChanged();
private: Esri::ArcGISRuntime::MapQuickView* mapView() const; void setMapView(Esri::ArcGISRuntime::MapQuickView* mapView); void populateWfsFeatureTable();
Esri::ArcGISRuntime::Map* m_map = nullptr; Esri::ArcGISRuntime::MapQuickView* m_mapView = nullptr; Esri::ArcGISRuntime::WfsFeatureTable* m_wfsFeatureTable = nullptr;};
#endif // DISPLAYWFSLAYER_H// [WriteFile Name=DisplayWfsLayer, Category=Layers]// [Legal]// Copyright 2019 Esri.//// Licensed under the Apache License, Version 2.0 (the "License");// you may not use this file except in compliance with the License.// You may obtain a copy of the License at// http://www.apache.org/licenses/LICENSE-2.0//// Unless required by applicable law or agreed to in writing, software// distributed under the License is distributed on an "AS IS" BASIS,// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.// See the License for the specific language governing permissions and// limitations under the License.// [Legal]
import QtQuickimport QtQuick.Controlsimport Esri.Samples
Item {
// add a mapView component MapView { id: view anchors.fill: parent
Component.onCompleted: { // Set the focus on MapView to initially enable keyboard navigation forceActiveFocus(); } }
// Declare the C++ instance which creates the map etc. and supply the view DisplayWfsLayerSample { id: model mapView: view }}// [Legal]// Copyright 2019 Esri.//// Licensed under the Apache License, Version 2.0 (the "License");// you may not use this file except in compliance with the License.// You may obtain a copy of the License at// http://www.apache.org/licenses/LICENSE-2.0//// Unless required by applicable law or agreed to in writing, software// distributed under the License is distributed on an "AS IS" BASIS,// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.// See the License for the specific language governing permissions and// limitations under the License.// [Legal]
// sample headers#include "DisplayWfsLayer.h"
// ArcGIS Maps SDK headers#include "ArcGISRuntimeEnvironment.h"
// Qt headers#include <QDir>#include <QGuiApplication>#include <QQmlApplicationEngine>
// Platform specific headers#ifdef Q_OS_WIN#include <Windows.h>#endif
#define STRINGIZE(x) #x#define QUOTE(x) STRINGIZE(x)
int main(int argc, char *argv[]){ Esri::ArcGISRuntime::ArcGISRuntimeEnvironment::setUseLegacyAuthentication(false); QGuiApplication app(argc, argv); app.setApplicationName(QString("DisplayWfsLayer"));
// Use of ArcGIS location services, such as basemap styles, geocoding, and routing services, // requires an access token. For more information see // https://links.esri.com/arcgis-runtime-security-auth.
// The following methods grant an access token:
// 1. User authentication: Grants a temporary access token associated with a user's ArcGIS account. // To generate a token, a user logs in to the app with an ArcGIS account that is part of an // organization in ArcGIS Online or ArcGIS Enterprise.
// 2. API key authentication: Get a long-lived access token that gives your application access to // ArcGIS location services. Go to the tutorial at https://links.esri.com/create-an-api-key. // Copy the API Key access token.
const QString accessToken = QString("");
if (accessToken.isEmpty()) { qWarning() << "Use of ArcGIS location services, such as the basemap styles service, requires" << "you to authenticate with an ArcGIS account or set the API Key property."; } else { Esri::ArcGISRuntime::ArcGISRuntimeEnvironment::setApiKey(accessToken); }
// Initialize the sample DisplayWfsLayer::init();
QString arcGISRuntimeImportPath = QUOTE(ARCGIS_RUNTIME_IMPORT_PATH);
#if defined(LINUX_PLATFORM_REPLACEMENT) // on some linux platforms the string 'linux' is replaced with 1 // fix the replacement paths which were created QString replaceString = QUOTE(LINUX_PLATFORM_REPLACEMENT); arcGISRuntimeImportPath = arcGISRuntimeImportPath.replace(replaceString, "linux", Qt::CaseSensitive);#endif
// Initialize application view QQmlApplicationEngine engine; // Add the import Path engine.addImportPath(QDir(QCoreApplication::applicationDirPath()).filePath("qml")); // Add the Runtime and Extras path engine.addImportPath(arcGISRuntimeImportPath);
// Set the source engine.load(QUrl("qrc:/Samples/Layers/DisplayWfsLayer/main.qml"));
return app.exec();}// Copyright 2019 ESRI//// All rights reserved under the copyright laws of the United States// and applicable international laws, treaties, and conventions.//// You may freely redistribute and use this sample code, with or// without modification, provided you include the original copyright// notice and use restrictions.//// See the Sample code usage restrictions document for further information.//
import QtQuick.Controlsimport Esri.Samples
ApplicationWindow { visible: true width: 800 height: 600
DisplayWfsLayer { anchors.fill: parent }}